module.exports = {
  'root': true,
  'parserOptions': {
    'ecmaVersion': 2018,
    'sourceType': 'module',
  },
  'env': {
    'node': true,
    'jest': true,
    'es6': true,
    'es2017': true,
  },
  'extends': [
    'eslint:all',
    'plugin:promise/recommended',
    'plugin:jest/all',
  ],
  'plugins': [
    'jest',
  ],
  'rules': {
    'array-bracket-newline': ['error', 'consistent'],
    'array-element-newline': 'off',
    'arrow-body-style': 'off',
    'brace-style': ['error', '1tbs', {'allowSingleLine': true}],
    'camelcase': 'warn',
    'capitalized-comments': 'off',
    'comma-dangle': ['error', 'always-multiline'],
    'curly': ["error", "multi-line"],
    'dot-location': ["error", "property"],
    'eqeqeq': ['error', 'smart'],
    'func-names': 'off',
    'func-style': ["error", "declaration", { "allowArrowFunctions": true }],
    'function-call-argument-newline': ["error", "consistent"],
    'guard-for-in': 'off',
    'id-length': 'off',
    'indent': ['error', 2],
    'init-declarations': 'off',
    'jest/consistent-test-it': ["error", {"fn": "test"}],
    // BUG: jest/require-top-level-describe doesn't seem to support
    //   describe.each()
    'jest/require-top-level-describe': 'off',
    'line-comment-position': 'off',
    'linebreak-style': ['error', 'unix'],
    'lines-around-comment': 'off',
    'max-len': ['warn', {'ignoreTrailingComments': true}],
    'max-lines-per-function': 'off',
    'max-statements': 'off',
    'max-statements-per-line': 'off',
    'multiline-comment-style': ['error', 'separate-lines'],
    'multiline-ternary': ['error', 'always-multiline'],
    'new-cap': 'off',
    'newline-per-chained-call': 'off',
    'no-alert': 'warn',
    'no-confusing-arrow': 'off',
    'no-console': 'warn',
    'no-continue': 'off',
    'no-eq-null': 'off',
    'no-extra-semi': 'error',
    'no-inline-comments': 'off',
    'no-invalid-this': 'off',
    'no-magic-numbers': 'off',
    'no-mixed-operators': 'off',
    'no-multi-assign': 'off',
    'no-multi-str': 'off',
    'no-new': 'warn',
    'no-plusplus': 'off',
    'no-prototype-builtins': 'off',
    'no-ternary': 'off',
    'no-underscore-dangle': 'off',
    'no-unused-expressions': ['error', {
      'allowShortCircuit': true,
      'allowTernary': true,
      'allowTaggedTemplates': true
    }],
    'no-unused-vars': 'warn',
    'no-use-before-define': 'warn',
    'no-warning-comments': 'off',
    'object-curly-newline': 'off',
    'object-property-newline': ['error', {
      'allowAllPropertiesOnSameLine': true,
    }],
    'one-var': ['error', 'never'],
    'padded-blocks': ['error', 'never'],
    'prefer-destructuring': 'warn',
    'quote-props': ['error', 'as-needed'],
    'quotes': ['error', 'single', {'avoidEscape': true}],
    'require-jsdoc': 'off',
    'semi': ['error', 'never'],
    'sort-imports': 'off',
    'sort-keys': 'off',
    'space-before-function-paren': ['error', {
      'anonymous': 'always',
      'named': 'never',
      'asyncArrow': 'always',
    }],
  },
}
